USE MATH

COMPONENT CargaResistiva
	"Modelo de carga resistiva destinada a disipar excesos de potencia"

-- Como hemos considerador los equipo de SMA, en este caso hemos seleecionador el WindyBoy
-- el inversor recibe la potencia de la turbina de viento y recibe la seal de limitacion
-- del inversor de baterias... 
-- En caso de haber excesos de potencia, esa potencia en exceso es redirigida hacia una resistencia
-- de manera que el exceso de energia se transforma en calor y se pierde.

PORTS

----------------------------------------------------------------------------
-- Salida: Pcarga
----------------------------------------------------------------------------

	OUT Pcargagrid					Pcargagridb
				

DATA

	REAL Pcarga=3000						"Potencia Activa consumida por una resistencia (W)"


DECLS

CONTINUOUS

	Pcargagridb.Pact=Pcarga
	
END COMPONENT

COMPONENT Fuente
	"Prueba para el limitador de potencia"

-- Srve qde prueba para verificar el funcionamiento del lmitador de potencia

PORTS

----------------------------------------------------------------------------
-- Salida: Pcarga
----------------------------------------------------------------------------

	OUT PotPuertos                 PotPuertosb
				

DATA

	REAL Ti=100							"Constante de tiempo (s)"


DECLS

	TABLE_1D tabfuente= {{0.,600,1200,1800,2400,3000,3600,4200,4800,5400,6000,6600,7200,7800}, {1300,1900,3500,4100,5600,7000,5600,4100,3500,1900,1300,700,350,200}}

	REAL fuente							"Velocidad del viento (m/seg)"
	REAL fuentea							"Velocidad del viento (m/seg)"
	
INIT

  fuente=1300

CONTINUOUS

	fuentea=timeTableStep(TIME,tabfuente) 
	
	Ti*fuente'=fuentea-fuente

	PotPuertosb.Pmech=fuente
		
END COMPONENT

