/*-----------------------------------------------------------------------------------------
 LIBRARY: RENEWABLE
 FILE: HisteresisRiego
 CREATION DATE: 08/03/2016
-----------------------------------------------------------------------------------------*/
USE MATH

COMPONENT HisteresisRiego
	"Control de altura tanque agua para riego"

PORTS

----------------------------------------------------------------------
-- Entradas: 
-- Altura del Tanque de riego
----------------------------------------------------------------------

	IN AlturaTanque					AlturaTanqueb
	
----------------------------------------------------------------------
-- Salida: 
-- Activacin de la bomba de alimentacin
----------------------------------------------------------------------

	OUT ContBomb						ContBomba

DATA 

	REAL Hmax=3.5						" Atura del tanque mxima (m)"
	REAL Hmin=0.5						" Atura del tanque mnima (m)"
		
		
DECLS
	 
	 REAL nbomba				" Encendido la bomba de alimentacion"
	 REAL HTanque				" Altura del tanque (m)"
	 INTEGER aux					" Variable auxiliar"

INIT

	nbomba=0
	aux=1


DISCRETE

  		 WHEN (HTanque>=Hmax) THEN
 				aux=1
       END WHEN
       
       WHEN (HTanque<=Hmin)THEN 
 				aux=2
       END WHEN   
		
		 
    	     
CONTINUOUS

	HTanque=AlturaTanqueb.HT
	
  	/*nbomba= ZONE (aux==0) 0
		    OTHERS  1
		    */
	nbomba= ZONE (aux==2) 1
				ZONE (aux==1) 0
				OTHERS 0

	
	ContBomba.nbomba=nbomba
		
END COMPONENT
