USE MATH


--------------------------------------------------------------------------------
--                        MODELO DE UNA BATERIA 
--------------------------------------------------------------------------------

COMPONENT bateria
	"Batera destinada al almacenamiento de energa"

PORTS

--------------------------------------------------------------------------------
-- 						Conexion Bateria - Cuk converter
--------------------------------------------------------------------------------    
    
     	OUT CCBatV			CCBatVa
     	IN CCBatI			CCBatIa

DATA

TABLE_1D Ive = {{0,30,31,32,33,34,35,36,37,38,39,40,60,61,62,63,64,65,66,67,68,69,70,100,101,102,103,104,105,106,107,108,109,110}, {10,10,8,6,4,2,0,-2,-4,-6,-8,-10,-10,-8,-6,-4,-2,0,2,4,6,8,10,10,8,6,4,2,0,-2,-4,-6,-8,-10}}
	
TABLE_1D Tve= {{0,55,60,90,120}, {25,25,0,0,0}}	

	REAL Cnom=140			"Capacidad nominal de la bateran (Ah)"
	REAL Inom=14			"Corriente a la capacidad nominal (A)"
	REAL Ctcoef=1.67		"Constante del modelo"
	REAL Acap=0.67			"Constante del modelo"
	REAL Bcap=0.9			"Constante del modelo"
	REAL alfac=0.005		"Coeficiente de Temperatura (C-1)"
	REAL Betac=0			"Coeficiente de Temperatura (C-2)"	
	REAL Vbodc=2.085		"Constante VOC en descarga (Volts)"
	REAL Kbodc=0.12		"Constante VOC en descarga (Volts)"
	REAL P1dc=4				"COnstante Rg en descarga (VAh)"
	REAL P2dc=1.3			"COnstante Rg en descarga"
	REAL P3dc=0.27			"COnstante Rg en descarga (Vh)"
	REAL P4dc=1.5			"COnstante Rg en descarga"
	REAL P5dc=0.02			"COnstante Rg en descarga (Vh)"
	REAL acmt=20.73		"Constante para la eficiencia"
	REAL bcmt=0.55			"Constante para la eficiencia"
	REAL Vboc=2				"Constante VOC en carga (Volts)"
	REAL Kboc=0.16			"Constante VOC en carga (Volts)"
	REAL P1c=6				"COnstante Rg en carga (VAh)"
	REAL P2c=0.86			"COnstante Rg en carga"
	REAL P3c=0.48			"COnstante Rg en carga (Vh)"
	REAL P4c=1.2			"COnstante Rg en carga"
	REAL P5c=0.036			"COnstante Rg en carga (Vh)"
	REAL alfardc=0.007	"Coeficiente de Temperatura descarga (C-1)"	
	REAL alfarc=0.025		"Coeficiente de Temperatura descarga (C-1)"
	REAL Agas=2.24			"Constante para calcular Vg"
	REAL Bgas=1.970		"Constante para calcular Vg"
	REAL alfagas=0.002	"Constante para calcular Vg"
	REAL alfafc=0.002		"Constante para calcular Vec"
	REAL Afonsc=2.45		"Constante para calcular Vec"
	REAL Bfonsc=2.011		"Constante para calcular Vec"
	REAL Atsc=17.3			"Constante para calcular tao"
	REAL Btsc=852			"Constante para calcular tao"
	REAL Ctsc=1.67			"Constante para calcular tao"
	REAL Tempmax=40		"Temperatura mxima de trabajo"
	//REAL Tref=10			"Temperatura de referencia (C)"
	

DECLS

	REAL Ibat				"Corriente que entra o sale de la bateria (Amp)"
	REAL Ibatp	
	EXPL REAL Vbat			"Voltaje de salida de la bateria (Volts)"
	EXPL REAL Vc			"Voltaje en la etapa de carga (Volts)"
	EXPL REAL Vsc			"Voltaje en la etapa de sobrevoltaje y saturacin (Volts)"
	EXPL REAL Vabd			"Voltaje entre saturacin y transicion(Volts)"
	EXPL REAL Vtransf		"Voltaje en la etapa de transicion carga - descarga (Volts)"
	EXPL REAL Vdc			"Voltaje en la etapa de descarga (Volts)"
	EXPL REAL Vago			"Voltaje en la etapa de Agotamiento (Volts)"
	EXPL REAL Vtransb		"Voltaje en la etapa de transicion descarga - carga (Volts)"
	
	EXPL REAL SOC			"Estado de carga de la batera"
	EXPL REAL tao			"Constante de tiempo para el fenomeno de sobrecarga"
	EXPL REAL LOE			"Nivel de Energa"
	//EXPL REAL SOH			"Estado de salud de la batera"
	EXPL REAL Cn			"Capacidad mxima de la batera"
	REAL C				   "Capacidad de la batera"
	EXPL REAL nc			"Eficiencia de carga de la batera"
	EXPL REAL deltaT		"Variacin de la temperatura (C)"
	EXPL REAL Vec			"Mxima tensin a la que puede llegar (Volts)"
	EXPL REAL Vg			"Tensin a la que se produce el efecto de gaseo electrolito (Volts)"
	//EXPL REAL nt			"Coeficiente de salud de temperatura (s-1)"
	//EXPL REAL nwz			"Coeficiente de salud de la zona de trabajo (s-1)"
	
	REAL nsc					"Activacin de la etapa de sobrecarga"
	REAL nsat				"Activacin de la etapa de saturacin"
	REAL ndes				"Activacin de la etapa de descarga"
	REAL ntrans				"Activacin de la etapa de transicion carga - descarga"
	REAL ntransb			"Activacin de la etapa de transicion descarga - carga"
	REAL ncarga				"Activacin de la etapa de carga"
	REAL nago				"Activacin de la etapa de agotamiento"
	REAL Tenv				"Temperatura ambiente (C)"  // Por el momento de considera la temperatura constante
			
	REAL SOCvg				"Estado de carga cuando Vbat=Vg"
	REAL x					"Auxiliar para calcular SOC y LOE "
	//REAL y					"Auxiliar para calcular SOH "
	REAL Vabb				"Voltaje de saturacin que se mantiene const mientras I>0 (Volts)"
	REAL Vcc					"Voltaje de carga para la etapa de transicion Car - Desc (Volts)"
	REAL Vca					"Voltaje de carga para la etapa de transicion Desc - Car (Volts)"
	REAL Vdcc				"Voltaje de descarga para la etapa de transicion Car - Desc (Volts)"
	REAL Vdca				"Voltaje de descarga para la etapa de transicion Desc - Car (Volts)"
	REAL Vdcero				"Voltaje de inicio para la etapa de agotamiento (Volts)"
	REAL Ibatant			"Corriente de la bateria con retrasos (Amps)"
			
INIT

   		
DISCRETE

 ------------------------------------------------------------------------------------- 
 -- Transicion de Carga a Descarga   
 -------------------------------------------------------------------------------------      
     
     
    WHEN ((Ibat<2))THEN
      				
 				Vcc= Vbat
 				
 				Vdcc= (Vbodc-(Kbodc*(1-SOC)))-((2/Cnom)*((P1dc/(1+(2**P2dc)))+(P3dc/(SOC**P4dc))+P5dc)*(1-alfardc*deltaT)) 
      
    END WHEN
     
    WHEN (((Ibat<-2) OR (Ibat>2)))THEN
      				
 				Vcc=0 
 				
 				Vdcc=0 				
 				
    END WHEN
     
 ------------------------------------------------------------------------------------- 
 -- Transicion de Descarga a Carga   
 -------------------------------------------------------------------------------------
     
    WHEN ((Ibat>-2))THEN
      				
 				Vca= (Vboc+(Kboc*SOC))+((2/Cnom)*((P1c/(1+(2**P2c)))+(P3c/((1-SOC)**P4c))+P5c)*(1-(alfarc*deltaT)))
 				
 				Vdca= Vbat 
      
    END WHEN
     
    WHEN ((Ibat>2) OR (Ibat<-2))THEN
      				
 				Vca=0 
 				
 				Vdca=0 				
 				
    END WHEN
   
     
 -------------------------------------------------------------------------------------   
 -- Calculo de SOCvg 
 -------------------------------------------------------------------------------------  
      
     WHEN ((Vbat>=Vg) AND (Ibat>2))THEN
 				
 				SOCvg=SOC
 				
     END WHEN
       
     WHEN (Vbat<Vg)THEN
     
            SOCvg=0
		 
     END WHEN
     
 ------------------------------------------------------------------------------------- 
 -- Interruptores que permiten saltar de una etapa a otra   
 ------------------------------------------------------------------------------------- 
 
      
     WHEN ((Vbat>Vg) AND (Vbat<(Vec-0.1)) AND (Ibat>2)) THEN  // CARGA -- SOBRECARGA // TRANSICIONDES -- SOBRECARGA  // SATURACION -- SOBRECARGA
     nsc=1      // Abro la zona de sobrecarga
     nsat=0     // Cierro la zona de saturacin
     ncarga=1   // Cierro la zona de carga
     ntrans=0   // Cierro la zona de transferencia de carga - descarga
     END WHEN
         
     WHEN (Vbat>(Vec-0.1) AND (Ibat>2)) THEN   // SOBRECARGA -- SATURACION // TRANSICIONDES -- SATURACION 
     nsat=1       // Abro la zona de saturacin
     nsc=0        // Cierro la zona de sobrecarga
     ntrans=0     // Cierro la zona de transferencia de carga - descarga
     ncarga=1    // Cierro la zona de carga
     Vabb=Vbat
     END WHEN          
     
     WHEN (Vbat<Vg AND (Ibat>2)) THEN // SOBRECARGA -- CARGA  //  TRANSICIONC -- CARGA  // TRANSICIONDES -- CARGA   
	  ncarga=0    // Abro la zona de carga     
     nsc=0        // Cierro la zona de sobrecarga
     ntransb=0		// Cierro la zona de transferencia de descarga - carga
     ntrans=0     // Cierro la zona de transferencia de carga - descarga
     END WHEN
         
     WHEN ((Ibat<2) AND ((nsat==1) OR (nsc==1) OR (ncarga==0))) THEN  // SATURACION, SOBRECARGA, CARGA - TRANSICIONDES
     ntrans=1 // Abro la zona de transicion
     ncarga=1 // Cierro la zona de sobrecarga
     nsc=0 // Cierro la zona de sobrecarga
     nsat=0 // Cierro la zona de saturacion
     END WHEN
     
     WHEN ((Ibat<-2) AND (ntrans==1)) THEN  // TRANSICIONDES - DESCARGA
     ntrans=0 // Cierro la zona de transicion
     ndes=1 // Abro la zona de descarga
     END WHEN 
     
     WHEN ((Ibat<-2) AND (Vbat<0)) THEN  // DESCARGA - AGOTAMIENTO
 	  Vdcero=Vbat
 	  nago=1  // Abro la zona de agotamiento
     ndes=0  // Cierro la zona de descarga
     END WHEN 

     WHEN ((Ibat>-2) AND ((nago==1) OR (ndes==1))) THEN  // DESCARGA; AGOTAMIENTO - TRANSICIONC
     ntransb=1 // Abro la zona de transicion
     nago=0 // Cierro la zona de agotamiento
     ndes=0 // Cierro la zona de descarga
     END WHEN  
     
     WHEN ((Ibat<-2) AND (ntransb==1) AND (Vbat<=0)) THEN  // TRANSICIONC - AGOTAMIENTO 
     ntransb=0 // Apago la zona de transicion descarga - carga
     nago=1 // abro la zona de agotamiento
     Vdcero=Vbat
     END WHEN     
     
     WHEN ((Ibat<-2) AND (ntransb==1) AND (Vbat>0)) THEN  // TRANSICIONC - DESCARGA 
     ntransb=0 // Apago la zona de transicion descarga - carga
     ndes=1  // abro la zona de descarga
     END WHEN        
 
 ------------------------------------------------------------------------------------- 
 -- Interruptores que permiten saltar de una etapa a otra   
 ------------------------------------------------------------------------------------- 
 
     WHEN (((Ibat-Ibatant)==0) AND (Ibat>2)) THEN  // Comienzo de la zona de sobrecarga
     C=Cnom*Ctcoef*(1+(alfac*deltaT)+(Betac*(deltaT**2)))/(1+(Acap*((abs(Ibat)/Inom)**Bcap)))
     END WHEN
     
      
CONTINUOUS

	Ibatp=CCBatIa.Ibat

	Ibat = timeTableInterp(TIME,Ive)
	Tenv= timeTableInterp(TIME,Tve)
	Ibatant=delay(Ibat,0.1)

       
----------------------------------------------------------------------------
--                  ESTADO DE CARGA
----------------------------------------------------------------------------
	
	deltaT=Tenv-25
	
	Cn=Cnom*Ctcoef*(1+alfac*abs(Tempmax-25)+Betac*abs(Tempmax-25)**2)
	
	x'= ZONE (nago==1) 0
	    OTHERS nc*abs(Ibat)
	
	SOC=(1/C)*x
	
	LOE=(1/Cn)*x	
		
----------------------------------------------------------------------------
--                  ESTADO DE SALUD DE LA BATERIA
----------------------------------------------------------------------------		
	
/*	nt=alfat*abs(Tenv-Tref)+betat

	y'=nt+nwz
   
   SOH=1-y
		
	nc10=(0.75*SOH)+0.25  // Cnew=C*nc10
	
	nq=0.01-(0.009*SOH)
	 */
	
	
----------------------------------------------------------------------------
--                  CONSTANTE DE REFERENCIA 
----------------------------------------------------------------------------


Vec=(Afonsc+(Bfonsc*(log(1+(Ibat/Cnom)))))*(1-(alfagas*deltaT))

Vg = (Agas+(Bgas*log(1+(Ibat/Cnom))))*(1-(alfagas*deltaT))

tao= ZONE ((Ibat>2)AND (ncarga==1))  Atsc/(1+(Btsc*(Ibat/Cnom)**Ctsc))
	  OTHERS 0

----------------------------------------------------------------------------
--                  EFICIENCIA DE CARGA 
----------------------------------------------------------------------------	  
	  
nc= ZONE ((Ibat>-2)) 1-exp((acmt/((Ibat/Inom)+bcmt))*(SOC-1))
	 ZONE (Ibat<=-2 AND (ndes==1)) -1   	 
	 OTHERS -1

----------------------------------------------------------------------------
--                  Voltaje de la bateria
----------------------------------------------------------------------------	


Vc= ZONE ((ncarga==0)) (Vboc+(Kboc*SOC))+((Ibat/Cnom)*((P1c/(1+(abs(Ibat)**P2c)))+(P3c/((1-SOC)**P4c))+P5c)*(1-(alfarc*deltaT)))
    OTHERS 0
    
Vsc= ZONE ((nsc==1)) Vg+((Vec-Vg)*(1-exp(((SOCvg*C)-(LOE*Cn))/(Ibat*tao))))
     OTHERS 0
     
Vabd=ZONE ((nsat==1)) Vabb
     OTHERS 0

Vtransf=ZONE ((ntrans==1)) ((Vcc-Vdcc)/(2*2))*Ibat+((Vcc+Vdcc)/2)
	     OTHERS 0

Vdc=ZONE ((ndes==1)) (Vbodc-(Kbodc*(1-SOC)))-((abs(Ibat)/Cnom)*((P1dc/(1+((abs(Ibat))**P2dc)))+(P3dc/(SOC**P4dc))+P5dc)*(1-alfardc*deltaT)) 
    OTHERS 0

Vago= ZONE ((nago==1)) Vdcero
      OTHERS 0
      
Vtransb=ZONE ((ntransb==1)) ((Vca-Vdca)/(2*2))*Ibat+((Vca+Vdca)/2)
	     OTHERS 0
	
Vbat=Vc+Vsc+Vabd+Vtransf+Vdc+Vago+Vtransb   

CCBatVa.Vbat=Vbat
     	 
END COMPONENT

// Logaritmo neperiano log
// Logaritmo base 10 log10

// Cosas por hacer

// f) Cambios de corriente de carga y descarga 
// i) Incorporacion de resto de efectos en la bateria
// j) Arreglar lo de la saturacion
// e) Ciclo a fondo
// g) Verificar sunny island
// h) Cargador Sunny Island


